using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections.ObjectModel;
using System.Globalization;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Diagnostics;
using System.Threading;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;

namespace WindowsFormsApplication2
{
    public partial class FormQuery : Form
    {
        private string listitem;
        private string findstr;
        private FeatureLayer shapeFileLayer;
        private string tableName;
        private string layer;
        private string layername;
        private string layername1;
        private FeatureLayer layerfile;
        private string filename;
        private Collection<FeatureSourceColumn> file;
        private Collection<Feature> item;
        
        
         public string findlist
        {
            get { return listitem; }
            set { cmb_qlyrselect.Items.Add(value); }

        }
        
        public FormQuery()
        {
            InitializeComponent();
        }


        private void cmd_gte_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" >= ");
        }

        private void cmd_equal_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" = ");
        }

        private void cmd_notequal_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" <> ");
        }

        private void cmd_lt_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" < ");
        }

        private void cmd_dot_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(".");
        }

        private void cmd_gt_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" > ");
        }

        private void cmd_lte_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" <= ");
        }

        private void cmd_mod_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" % ");
        }

        private void btn_is_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" IS ");
        }

        private void btn_like_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" LIKE ");
        }

        private void btn_or_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" OR ");
        }

        private void btn_and_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" AND ");
        }

        private void btn_not_Click(object sender, EventArgs e)
        {
            txt_qfinal.AppendText(" NOT ");
        }

        private void cmb_qlyrselect_SelectedIndexChanged(object sender, EventArgs e)
        {

            txt_qfinal.AppendText(" SELECT * FROM ");
            layer = cmb_qlyrselect.SelectedItem.ToString();
            layername = new FileInfo(layer).Name;

            filename = Path.ChangeExtension(layername, ".DBF");
            string f = Path.GetFileNameWithoutExtension(filename);
            ShapeFileFeatureLayer layerfile = new ShapeFileFeatureLayer(filename);
            txt_qfinal.AppendText(f);
            txt_qfinal.AppendText(" WHERE ");

            layerfile.Open();

            int indx = cmb_qatrrselect.SelectedIndex;

            file = layerfile.QueryTools.GetColumns();

            int cnt = file.Count;
            for (int i = 0; i < cnt; i++)
            {
                cmb_qatrrselect.Items.Add(file.ElementAt(i));
            }



            layerfile.Close();      

        }

        

        private void FormQuery_FormClosing(object sender, FormClosingEventArgs e)
        {
            cmb_qlyrselect.Items.Clear();
            cmb_qlyrselect.Text = " ";
            cmb_qatrrselect.Items.Clear();
            cmb_qatrrselect.Text = " ";
            txt_val.Text = " ";
            txt_qfinal.Text = " ";


        }
        private void cmd_apply_Click(object sender, EventArgs e)
        {
            Mapexplorer mp1 = new Mapexplorer();
            findstr = txt_val.Text;
            string column = cmb_qatrrselect.SelectedItem.ToString();
            txt_qfinal.AppendText(findstr);

            layer = cmb_qlyrselect.SelectedItem.ToString();
            layername = new FileInfo(layer).FullName;
            layername1 = Path.GetFileNameWithoutExtension(layer);
            
            ShapeFileFeatureLayer layerfile = new ShapeFileFeatureLayer(layername);


            layerfile.Open();
            DataTable db = layerfile.QueryTools.ExecuteQuery(txt_qfinal.Text);

            layerfile.Close();
            dgrid.DataSource = db;
            
            FeatureLayer fl = dgrid.SelectAll();
            //dgrid.SelectAll();
            String qry = txt_qfinal.Text;
            WinformsMap winformsMap1 = (WinformsMap)this.Parent;

            ShapeFileFeatureLayer worldLayer = (ShapeFileFeatureLayer)winformsMap1.FindFeatureLayer(layername);
            InMemoryFeatureLayer highlightLayer = (InMemoryFeatureLayer)winformsMap1.FindFeatureLayer("HighlightLayer");

            worldLayer.Open();

            Collection<Feature> features = worldLayer.QueryTools.

            worldLayer.Close();

            if (highlightLayer.InternalFeatures.Count > 0)
            {
                highlightLayer.InternalFeatures.Clear();
            }

            foreach (Feature feature in features)
            {
                highlightLayer.InternalFeatures.Add(feature);
            }


            winformsMap1.Refresh(winformsMap1.Overlays["HighlightOverlay"]);
          
        }

        private void FormQuery_FormClosed(object sender, FormClosedEventArgs e)
        {
            cmb_qlyrselect.Items.Clear();
            cmb_qatrrselect.Items.Clear();
            txt_val.Text = " ";
            txt_qfinal.Text = " ";
        }

        private void cmb_qatrrselect_SelectedIndexChanged(object sender, EventArgs e)
        {
            string col = cmb_qatrrselect.SelectedItem.ToString();
            txt_qfinal.AppendText(col);
        }

        

        
        
    }
}
